ICU 65.1 65.1

Public Member Functions | Friends
icu::FormattedRelativeDateTime Class Reference

An immutable class containing the result of a relative datetime formatting operation. More...

`#include <reldatefmt.h>`

Inheritance diagram for icu::FormattedRelativeDateTime:

## Public Member Functions
| FormattedRelativeDateTime ()
| Default constructor; makes an empty FormattedRelativeDateTime. More...
| FormattedRelativeDateTime (FormattedRelativeDateTime &&src) U_NOEXCEPT
| Move constructor: Leaves the source FormattedRelativeDateTime in an undefined state. More...
virtual | ~FormattedRelativeDateTime () U_OVERRIDE
| Destruct an instance of FormattedRelativeDateTime. More...
| FormattedRelativeDateTime (const FormattedRelativeDateTime &)=delete
| Copying not supported; use move constructor instead. More...
FormattedRelativeDateTime & | operator= (const FormattedRelativeDateTime &)=delete
| Copying not supported; use move assignment instead. More...
FormattedRelativeDateTime & | operator= (FormattedRelativeDateTime &&src) U_NOEXCEPT
| Move assignment: Leaves the source FormattedRelativeDateTime in an undefined state. More...
UnicodeString | toString (UErrorCode &status) const U_OVERRIDE
| Returns the formatted string as a self-contained UnicodeString. More...
UnicodeString | toTempString (UErrorCode &status) const U_OVERRIDE
| Returns the formatted string as a read-only alias to memory owned by the FormattedValue. More...
Appendable & | appendTo (Appendable &appendable, UErrorCode &status) const U_OVERRIDE
| Appends the formatted string to an Appendable. More...
UBool | nextPosition (ConstrainedFieldPosition &cfpos, UErrorCode &status) const U_OVERRIDE
| Iterates over field positions in the FormattedValue. More...
Public Member Functions inherited from icu::FormattedValue
virtual | ~FormattedValue ()

## Friends
class | RelativeDateTimeFormatter

## Detailed Description

An immutable class containing the result of a relative datetime formatting operation.

Instances of this class are immutable and thread-safe.

Not intended for public subclassing.

Draft:
  This API may be changed in the future versions and was introduced in ICU 64

Definition at line 277 of file reldatefmt.h.

## Constructor & Destructor Documentation

## ◆ FormattedRelativeDateTime() [1/3]

icu::FormattedRelativeDateTime::FormattedRelativeDateTime | ( |  | ) |
| inline

Default constructor; makes an empty FormattedRelativeDateTime.

Draft:
  This API may be changed in the future versions and was introduced in ICU 64

Definition at line 283 of file reldatefmt.h.

References icu::FormattedValue::appendTo(), icu::FormattedValue::nextPosition(), icu::FormattedValue::toString(), icu::FormattedValue::toTempString(), U_NOEXCEPT, U_OVERRIDE, and U_ZERO_ERROR.

## ◆ FormattedRelativeDateTime() [2/3]

icu::FormattedRelativeDateTime::FormattedRelativeDateTime | ( | FormattedRelativeDateTime && | src | ) |

Move constructor: Leaves the source FormattedRelativeDateTime in an undefined state.

Draft:
  This API may be changed in the future versions and was introduced in ICU 64

## ◆ ~FormattedRelativeDateTime()

virtual icu::FormattedRelativeDateTime::~FormattedRelativeDateTime | ( |  | ) |
| virtual

Destruct an instance of FormattedRelativeDateTime.

Draft:
  This API may be changed in the future versions and was introduced in ICU 64

## ◆ FormattedRelativeDateTime() [3/3]

icu::FormattedRelativeDateTime::FormattedRelativeDateTime | ( | const FormattedRelativeDateTime & |  | ) |
| delete

Copying not supported; use move constructor instead.

## Member Function Documentation

## ◆ appendTo()

Appendable& icu::FormattedRelativeDateTime::appendTo | ( | Appendable & | appendable,
|  | UErrorCode & | status
| ) |  | const
| virtual

Appends the formatted string to an Appendable.

Parameters

  appendable | The Appendable to which to append the string output.
  status | Set if an error occurs.

Returns
  The same Appendable, for chaining.

Draft:
  This API may be changed in the future versions and was introduced in ICU 64

See also
  Appendable

Implements icu::FormattedValue.

## ◆ nextPosition()

UBool icu::FormattedRelativeDateTime::nextPosition | ( | ConstrainedFieldPosition & | cfpos,
|  | UErrorCode & | status
| ) |  | const
| virtual

Iterates over field positions in the FormattedValue.

This lets you determine the position of specific types of substrings, like a month or a decimal separator.

To loop over all field positions:

    ConstrainedFieldPosition cfpos;
    while (fmtval.nextPosition(cfpos, status)) {
        // handle the field position; get information from cfpos
    }

Parameters

  cfpos | The object used for iteration state. This can provide constraints to iterate over only one specific category or field; see ConstrainedFieldPosition::constrainCategory and ConstrainedFieldPosition::constrainField.
  status | Set if an error occurs.

Returns
  TRUE if a new occurrence of the field was found; FALSE otherwise or if an error was set.

Draft:
  This API may be changed in the future versions and was introduced in ICU 64

Implements icu::FormattedValue.

## ◆ operator=() [1/2]

FormattedRelativeDateTime& icu::FormattedRelativeDateTime::operator= | ( | const FormattedRelativeDateTime & |  | ) |
| delete

Copying not supported; use move assignment instead.

## ◆ operator=() [2/2]

FormattedRelativeDateTime& icu::FormattedRelativeDateTime::operator= | ( | FormattedRelativeDateTime && | src | ) |

Move assignment: Leaves the source FormattedRelativeDateTime in an undefined state.

Draft:
  This API may be changed in the future versions and was introduced in ICU 64

## ◆ toString()

UnicodeString icu::FormattedRelativeDateTime::toString | ( | UErrorCode & | status | ) | const
| virtual

Returns the formatted string as a self-contained UnicodeString.

If you need the string within the current scope only, consider toTempString.

Parameters

  status | Set if an error occurs.

Returns
  a UnicodeString containing the formatted string.

Draft:
  This API may be changed in the future versions and was introduced in ICU 64

Implements icu::FormattedValue.

## ◆ toTempString()

UnicodeString icu::FormattedRelativeDateTime::toTempString | ( | UErrorCode & | status | ) | const
| virtual

Returns the formatted string as a read-only alias to memory owned by the FormattedValue.

The return value is valid only as long as this FormattedValue is present and unchanged in memory. If you need the string outside the current scope, consider toString.

The buffer returned by calling UnicodeString::getBuffer() on the return value is guaranteed to be NUL-terminated.

Parameters

  status | Set if an error occurs.

Returns
  a temporary UnicodeString containing the formatted string.

Draft:
  This API may be changed in the future versions and was introduced in ICU 64

Implements icu::FormattedValue.

The documentation for this class was generated from the following file:

- reldatefmt.h